<script lang="ts">
import Vue from 'vue';
import DepartmentAccordion from './department-accordion.vue';
import { filterData } from '~/services/jobs/all-jobs.service';

export default Vue.extend({
  name: 'JobsControls',
  components: {
    DepartmentAccordion,
  },
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      content: [],
      location: 'View all locations',
      expanded: [],
    };
  },
  computed: {
    filteredContent() {
      if (this.location && this.location !== 'View all locations') {
        return this.content.map((division) => ({
          family: division.family,
          departments: division.departments.map((department) => ({
            ...department,
            jobListings: department.jobListings.map((item) => ({
              ...item,
              jobs: item.jobs.filter(
                (job) => job.location.name === this.location,
              ),
            })),
          })),
        }));
      } else {
        return this.content;
      }
    },
  },
  watch: {
    location: {
      handler(newValue) {
        window.dataLayer = window.dataLayer || [];
        window.dataLayer.push({
          jobLocation: newValue,
          event: 'jobFilter',
        });
      },
      immediate: false, // we do not want this to run on initial creation
    },
  },
  created() {
    (async () => {
      await this.$store.dispatch('fetchGreenhouseData');
      this.content = this.data.divisions.map((division) => {
        return {
          family: division.family,
          departments: filterData(
            division.departments,
            this.$store.state.greenhouseApiData.departments,
          ),
        };
      });
    })();
  },
  mounted() {
    // for page visitors with department name in hash
    window.onload = () => {
      const departmentId = window.location.hash;
      if (departmentId) {
        const withoutHash = departmentId.replace(/^#/, '');
        this.expanded = [withoutHash];

        this.$nextTick(() => {
          const section = document.getElementById(withoutHash);
          if (section) {
            section.scrollIntoView({ behavior: 'smooth', block: 'start' });
          }
        });
      }
    };
  },

  methods: {
    calculateNumberOfOpenings(departments) {
      let totalJobs = 0;

      departments.forEach((department) => {
        totalJobs += department.jobListings.reduce(
          (total, jobListing) => total + jobListing.jobs.length,
          0,
        );
      });

      return totalJobs;
    },
    shouldRenderDepartmentAccordion(departmentObj) {
      return departmentObj.jobListings.some((item) => item.jobs.length > 0);
    },

    hasJobs(item) {
      return item.jobs && item.jobs.length > 0;
    },
    handleClickedFamily(name: string) {
      this.expanded = this.expanded.includes(name)
        ? this.expanded.filter((item) => item !== name)
        : [...this.expanded, this.parseToKebabCase(name)];
    },

    parseToKebabCase(string: string) {
      if (!string) return '';
      const kebabCaseString = string
        .replace(/\?/g, '') // Remove '?'
        .replace(/[^\w\s]/g, '-') // Replace non-alphanumeric and non-whitespace characters with '-'
        .replace(/\s+/g, '-') // Replace spaces with hyphens
        .replace(/-+/g, '-') // Remove consecutive hyphens
        .toLowerCase();

      return kebabCaseString.toLowerCase();
    },
  },
});
</script>

<template>
  <SlpContainer>
    <div class="jobs-content">
      <article class="controls">
        <div class="filter">
          <label for="location-filter-dropdown">
            <SlpTypography variant="body2" tag="div" class="slp-mb-8">{{
              data.controls.locationFilter.accessibility_label
            }}</SlpTypography>
          </label>

          <SlpDropdown
            v-model="location"
            class="filter-dropdown"
            name="location-filter-dropdown"
            dropdown-label="Sort By"
            :options="data.controls.locationFilter.dropdownItems"
          />
        </div>
      </article>
      <article>
        <div
          v-for="item in filteredContent"
          :id="parseToKebabCase(item.family)"
          :key="item.family"
        >
          <button
            :id="`${item.family}-button`"
            class="group__container"
            type="button"
            :aria-controls="`${item.family}-content`"
            :data-inbound-analytics="item.family"
            :data-toggle-group="item.family"
            :aria-expanded="expanded.includes(parseToKebabCase(item.family))"
            :data-ga-toggle="
              expanded.includes(parseToKebabCase(item.family))
                ? 'collapse'
                : 'expand'
            "
            @click="handleClickedFamily(parseToKebabCase(item.family))"
          >
            <div class="group__title slp-mb-8">
              <span class="group__title--division">
                <SlpTypography tag="h2" variant="heading3-bold">{{
                  item.family
                }}</SlpTypography>
                <router-link
                  :to="{ path: '', hash: parseToKebabCase(item.family) }"
                >
                  <SlpIcon
                    name="anchor"
                    size="sm"
                    variant="marketing"
                    color="#7759C2"
                  />
                </router-link>
              </span>

              <SlpTypography tag="p" variant="body1">
                <span class="group__title--openings">
                  {{
                    `${calculateNumberOfOpenings(item.departments)} ${
                      calculateNumberOfOpenings(item.departments) === 1
                        ? 'opening'
                        : 'openings'
                    }`
                  }}
                </span>
              </SlpTypography>
            </div>
            <SlpTypography
              v-if="expanded.includes(parseToKebabCase(item.family))"
              class="group__link"
              tag="span"
              variant="body2-bold"
              >{{ data.expandText.hideAll }}</SlpTypography
            >
            <SlpTypography
              v-else
              tag="span"
              variant="body2-bold"
              class="group__link"
              >{{ data.expandText.showAll }}</SlpTypography
            >
          </button>
          <div
            v-show="
              expanded.includes(parseToKebabCase(item.family)) ||
              expanded.includes('view-all')
            "
          >
            <template v-for="department in item.departments">
              <DepartmentAccordion
                v-if="shouldRenderDepartmentAccordion(department)"
                :key="department.departmentName"
                :department-data="department"
              />
            </template>
          </div>
        </div>
      </article>
    </div>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.jobs-content {
  padding: 72px 0;
}
.controls {
  display: flex;
  gap: 30px;
  margin-bottom: 24px;

  @media (max-width: $breakpoint-md) {
    gap: 16px;
    flex-wrap: wrap;
  }

  .filter {
    width: 345px;

    @media (max-width: $breakpoint-md) {
      width: 100%;
    }

    label {
      visibility: hidden;
      width: 1px;
      height: 1px;
    }
  }
}

.group {
  &__container {
    border: none;
    width: 100%;
    cursor: pointer;
    display: flex;
    align-items: center;
    text-align: left;
    justify-content: space-between;
    padding: 32px 0;

    @media (max-width: $breakpoint-md) {
      flex-direction: row;
      align-items: normal;
    }
  }

  &__title {
    &--division {
      display: flex;
      align-items: center;
      gap: 8px;
    }

    &--openings {
      color: $color-text-200;
    }
  }

  &__link {
    display: block;
    text-decoration: underline;
    color: $color-text-link-100;
    cursor: pointer;
    border: none;
    @media (max-width: $breakpoint-md) {
      text-align: right;
      flex: 1 0 30%;
    }
  }
}
</style>
